Package org.apache.commons.compress.compressors.deflate

# Class DeflateCompressorOutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
org.apache.commons.compress.CompressFilterOutputStream<DeflaterOutputStream>
org.apache.commons.compress.compressors.CompressorOutputStream<DeflaterOutputStream>
org.apache.commons.compress.compressors.deflate.DeflateCompressorOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class DeflateCompressorOutputStream extends CompressorOutputStream<DeflaterOutputStream>
Deflate compressor. Calling flush()

Calling `flush()` flushes the encoder and calls `outputStream.flush()`. All buffered pending data will then be decompressible from the output stream. Calling this function very often may increase the compressed file size a lot.

Since:
  1.9

- ## Field Summary

  ### Fields inherited from class java.io.FilterOutputStream

  `out`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DeflateCompressorOutputStream(OutputStream outputStream)`
  Creates a Deflate compressed output stream with the default parameters.
  `DeflateCompressorOutputStream(OutputStream outputStream, DeflateParameters parameters)`
  Creates a Deflate compressed output stream with the specified parameters.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `void`
  `finish()`
  Finishes compression without closing the underlying stream.
  `void`
  `flush()`
  Flushes the encoder and calls `outputStream.flush()`.
  `void`
  `write(byte[] buf, int off, int len)`

  ### Methods inherited from class org.apache.commons.compress.CompressFilterOutputStream

  `checkOpen, isClosed, isFinished, out, write, write, writeUsAscii, writeUsAsciiRaw, writeUtf8`

  ### Methods inherited from class java.io.FilterOutputStream

  `write, write`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DeflateCompressorOutputStream

    public DeflateCompressorOutputStream(OutputStream outputStream)
    Creates a Deflate compressed output stream with the default parameters.
    Parameters:
      `outputStream` - the stream to wrap

  - ### DeflateCompressorOutputStream

    public DeflateCompressorOutputStream(OutputStream outputStream, DeflateParameters parameters)
    Creates a Deflate compressed output stream with the specified parameters.
    Parameters:
      `outputStream` - the stream to wrap
      `parameters` - the deflate parameters to apply

- ## Method Details

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `CompressFilterOutputStream<DeflaterOutputStream>`
    Throws:
      `IOException`

  - ### finish

    public void finish() throws IOException
    Finishes compression without closing the underlying stream.

    No more data can be written to this stream after finishing.

    Overrides:
      `finish` in class `CompressFilterOutputStream<DeflaterOutputStream>`
    Throws:
      `IOException` - on error

  - ### flush

    public void flush() throws IOException
    Flushes the encoder and calls `outputStream.flush()`. All buffered pending data will then be decompressible from the output stream. Calling this function very often may increase the compressed file size a lot.
    Specified by:
      `flush` in interface `Flushable`
    Overrides:
      `flush` in class `FilterOutputStream`
    Throws:
      `IOException`

  - ### write

    public void write(byte[] buf, int off, int len) throws IOException
    Overrides:
      `write` in class `FilterOutputStream`
    Throws:
      `IOException`